gulp = require('gulp');
shell = require('gulp-shell');
Elixir = require('laravel-elixir');
git = require('gulp-git')
gulpFunction = require("gulp-function")
del = require('del')
q = require('q')
streamqueue = require('streamqueue');
_ = require('underscore')
#run = require('run-sequence')
Task = Elixir.Task;
Log = Elixir.Log

tmp_dir = './tmp/source'
repo_url='http://gitlab.dmz/kodeks/source.git'
checkout_branch = 'master'
source = {}

clean = (path)->
	if _.isFunction path or path == tmp_dir
		path = tmp_dir
		Log.message '   - clean ' + path

	def = q.defer()

	del([path]).then ()->
		def.resolve()

	return def.promise

clone = ()->
	def = q.defer()
	Log.message '   - cloning to ' + tmp_dir

	git.clone repo_url, {args: tmp_dir, quiet: true}, (err)->
		if (err)
			(new Elixir.Notification).error(err, 'Source Failed!');
			def.reject(err)
		else
			def.resolve()

	return def.promise

checkout = (b)->
	if !b?
		b = checkout_branch

	def = q.defer()
	Log.message '   - checkout branch to ' + b
	git.checkout b, {cwd: tmp_dir}, (err)->
		Log.message '1231213 ' + b
		if (err)
			(new Elixir.Notification).error(err, 'Source Failed!');
			def.reject(err)
		else
			def.resolve()

	return def.promise

copy = ()->
	if !_.isEmpty source
		Log.message '   - copy to '

		_.each source, (projects, branch)->
			Q = new streamqueue({ objectMode: true })
			_.each projects, (projects, path)->
				_.each projects, (project)->
					clean path
					Q.queue gulp.src("#{tmp_dir}/user/projects/#{project}/**/*", {"base" : "#{tmp_dir}/user/projects"})
					.pipe(gulpFunction(()->
						checkout_branch = branch
					, 'forFirst'))
					.pipe(gulpFunction(checkout, 'atEnd'))
					.pipe(gulp.dest(path))
			Q.done()


return Elixir.extend 'source', (options, r_url)->
	repo_url ?= r_url

	_.each options, (option)->
		_.each option.projects, (project, branch)->
			if !_.isArray project
				project = [project]
			if !source[branch]?
				source[branch] = {}
			source[branch]?[option.path] = _.union project, source[branch]

	return new Task 'source', ->
		return q()
		.then ()->
			Log.heading('Starting source')
		#.then clean
		#.then clone
		.then copy




